import javax.naming.*;

public class JNDITree
{
	public static void main(String[] args) {
		Context ctx=null;
		try {
			ctx = new InitialContext();
			listContext (ctx,"");
		} 
		catch (NamingException ex) {
			System.err.println (ex);
			System.exit(1);
		}
	}

	private static void listContext (Context ctx, String indent) {
		try {
			NamingEnumeration list = ctx.listBindings("");
			while (list.hasMore()) {
				Binding item = (Binding)list.next();
				String className = item.getClassName();
				String name = item.getName();
				System.out.println(indent+className+" "+name);
				Object o = item.getObject();
				if (o instanceof javax.naming.Context)
					listContext ((Context)o,indent+"  ");
			}
		}
		catch (NamingException ex) {
			System.err.println ("List error: "+ex);
		}
	}
}


